// GFX.SHADER
// 
// this file contains shaders that are used by the programmers to
// generate special effects not attached to specific geometry.  This
// also has 2D shaders such as fonts, etc.
//
// the REGION shader is generated by the map editor on temporary
// brushes around a selected area for testing parts of maps
textures/REGION
{
	surfaceparm nolightmap
}

// the background for the netgraph
lagometer
{
	nopicmip
	{
		map gfx/2d/lag.tga
	}
}

// blinked on top of lagometer when connection is interrupted
disconnected
{
	nopicmip
	{
		map gfx/2d/net.tga
	}
}

white
{
	{
		map $whiteimage 
		blendfunc blend
		rgbGen Vertex
	}
}


// used to break up the blur on levelshots
levelShotDetail
{
	nopicmip
	{
		map textures/sfx/detail.tga
		blendfunc gl_dst_color gl_src_color
		rgbGen identity
	}
}

//
// special effects as seen on players
//
powerups/battleSuit
{
	deformVertexes wave 100 sin 1 0 0 0 
	{
		map textures/effects/envmapgold2.tga
		blendfunc add
		tcMod turb 0 0.15 0 0.3
		tcMod rotate 333
		tcMod scroll 0.3 0.3
		tcGen environment 
	}
}

powerups/battleWeapon
{
	deformVertexes wave 100 sin 0.5 0 0 0 
	{
		map textures/effects/envmapgold2.tga
		blendfunc add
		tcMod turb 0 0.15 0 0.3
		tcMod rotate 333
		tcMod scroll 0.3 0.3
		tcGen environment 
	}
}

powerups/invisibility
{
	{
		map textures/effects/invismap.tga
		blendfunc add
		tcMod turb 0 0.15 0 0.25
		tcGen environment 
	}
}

powerups/quad
{
	deformVertexes wave 100 sin 3 0 0 0 
	{
		map textures/effects/quadmap2.tga
		blendfunc add
		tcMod rotate 30
		tcMod scroll 1 0.1
		tcGen environment 
	}
}

powerups/quadWeapon
{
	deformVertexes wave 100 sin 0.5 0 0 0 
	{
		map textures/effects/quadmap2.tga
		blendfunc add
		tcMod rotate 30
		tcMod scroll 1 0.1
		tcGen environment 
	}
}

powerups/regen
{
	deformVertexes wave 100 sin 3 0 0 0 
	{
		map textures/effects/regenmap2.tga
		blendfunc add
		tcMod rotate 30
		tcMod scroll 1 0.1
		tcGen environment 
	}
}

//=========================
//
// holdable item icons
//
icons/teleporter
{
	nopicmip
	{
		map icons/teleporter.tga
		blendfunc blend
	}
}

icons/medkit
{
	nopicmip
	{
		map icons/medkit.tga
		blendfunc blend
	}
}

//
// powerup icons
//
icons/envirosuit
{
	nopicmip
	{
		map icons/envirosuit.tga
		blendfunc blend
	}
}

icons/quad
{
	nopicmip
	{
		map icons/quad.tga
		blendfunc blend
	}
}

icons/haste
{
	nopicmip
	{
		map icons/haste.tga
		blendfunc blend
	}
}

icons/invis
{
	nopicmip
	{
		map icons/invis.tga
		blendfunc blend
	}
}

icons/regen
{
	nopicmip
	{
		map icons/regen.tga
		blendfunc blend
	}
}

icons/flight
{
	nopicmip
	{
		map icons/flight.tga
		blendfunc blend
	}
}

// reward medals used in the game floating over client's heads
medal_impressive
{
	nopicmip
	{
		clampmap menu/medals/medal_impressive.tga
		blendfunc blend
	}
}

medal_excellent
{
	nopicmip
	{
		clampmap menu/medals/medal_excellent.tga
		blendfunc blend
	}
}

medal_gauntlet
{
	nopicmip
	{
		clampmap menu/medals/medal_gauntlet.tga
		blendfunc blend
	}
}

//
// weapon icons
//
icons/iconw_gauntlet
{
	nopicmip
	{
		map icons/iconw_gauntlet.tga
		blendfunc blend
	}
}

icons/iconw_machinegun
{
	nopicmip
	{
		map icons/iconw_machinegun.tga
		blendfunc blend
	}
}

icons/iconw_rocket
{
	nopicmip
	{
		map icons/iconw_rocket.tga
		blendfunc blend
	}
}

icons/iconw_shotgun
{
	nopicmip
	{
		map icons/iconw_shotgun.tga
		blendfunc blend
		rgbGen identityLighting
	}
}

icons/iconw_grenade
{
	nopicmip
	{
		map icons/iconw_grenade.tga
		blendfunc blend
	}
}

icons/iconw_lightning
{
	nopicmip
	{
		map icons/iconw_lightning.tga
		blendfunc blend
	}
}

icons/iconw_plasma
{
	nopicmip
	{
		map icons/iconw_plasma.tga
		blendfunc blend
	}
}

icons/iconw_railgun
{
	nopicmip
	{
		map icons/iconw_railgun.tga
		blendfunc blend
	}
}

icons/iconw_bfg
{
	nopicmip
	{
		map icons/iconw_bfg.tga
		blendfunc blend
	}
}

icons/iconw_grapple
{
	nopicmip
	{
		map icons/iconw_grapple.tga
		blendfunc blend
	}
}

//
// ammo icons
//
icons/icona_machinegun
{
	nopicmip
	{
		map icons/icona_machinegun.tga
		blendfunc blend
	}
}

icons/icona_rocket
{
	nopicmip
	{
		map icons/icona_rocket.tga
		blendfunc blend
	}
}

icons/icona_shotgun
{
	nopicmip
	{
		map icons/icona_shotgun.tga
		blendfunc blend
		rgbGen identityLighting
	}
}

icons/icona_grenade
{
	nopicmip
	{
		map icons/icona_grenade.tga
		blendfunc blend
	}
}

icons/icona_lightning
{
	nopicmip
	{
		map icons/icona_lightning.tga
		blendfunc blend
	}
}

icons/icona_plasma
{
	nopicmip
	{
		map icons/icona_plasma.tga
		blendfunc blend
	}
}

icons/icona_railgun
{
	nopicmip
	{
		map icons/icona_railgun.tga
		blendfunc blend
	}
}

icons/icona_bfg
{
	nopicmip
	{
		map icons/icona_bfg.tga
		blendfunc blend
	}
}

//
// armor icons
//
icons/iconr_shard
{
	nopicmip
	{
		map icons/iconr_shard.tga
		blendfunc blend
	}
}

icons/iconr_yellow
{
	nopicmip
	{
		map icons/iconr_yellow.tga
		blendfunc blend
	}
}

icons/iconr_red
{
	nopicmip
	{
		map icons/iconr_red.tga
		blendfunc blend
	}
}

//
// health icons
//
icons/iconh_green
{
	nopicmip
	{
		map icons/iconh_green.tga
		blendfunc blend
	}
}

icons/iconh_yellow
{
	nopicmip
	{
		map icons/iconh_yellow.tga
		blendfunc blend
	}
}

icons/iconh_red
{
	nopicmip
	{
		map icons/iconh_red.tga
		blendfunc blend
	}
}

icons/iconh_mega
{
	nopicmip
	{
		map icons/iconh_mega.tga
		blendfunc blend
	}
}

//
// CTF icons
//
icons/iconf_red
{
	nopicmip
	{
		map icons/iconf_red.tga
		blendfunc blend
	}
}

icons/iconf_blu
{
	nopicmip
	{
		map icons/iconf_blu.tga
		blendfunc blend
	}
}

//===================================================
gfx/2d/menuinfo
{
	nopicmip
	{
		map gfx/2d/menuinfo.tga
	}
}

gfx/2d/menuinfo2
{
	nopicmip
	{
		map gfx/2d/menuinfo2.tga
	}
}

gfx/2d/quit
{
	nomipmaps
	{
		map gfx/2d/quit.tga
	}
}

gfx/2d/cursor
{
	nomipmaps
	{
		map gfx/2d/cursor.tga
	}
}

//==========================================================================
sprites/balloon3
{
	{
		map sprites/balloon4.tga
		blendfunc blend
	}
}

// this is an example of a crossfaded animation cycle
textures/animationTest
{
	qer_editorimage textures/liquids/bloodwater1.tga
	{
		animmap 0.5 textures/liquids/bloodwater1.tga textures/liquids/pool.tga textures/liquids/slime7.tga 
	}
	{
		animmap 0.5 textures/liquids/pool.tga textures/liquids/slime7.tga textures/liquids/bloodwater1.tga 
		blendfunc blend
		alphaGen wave sawtooth 0 1 0 0.5 
	}
	{
		map $lightmap 
		blendfunc filter
		tcGen lightmap 
	}
}

teleportEffect
{
	cull disable
	{
		map gfx/misc/teleportEffect2.tga
		blendfunc add
		rgbGen entity
		tcMod scale 1 4
		tcMod scroll 0 2
	}
}

// markShadow is the very cheap blurry blob underneat the player
markShadow
{
	polygonoffset
	{
		map gfx/damage/shadow.tga
		blendfunc gl_zero gl_one_minus_src_color
		rgbGen Vertex
	}
}

// projectionShadow is used for cheap squashed model shadows
projectionShadow
{
	polygonoffset
	{
		map $whiteimage 
		rgbGen wave square 0 0 0 0 
	}
}

// wake is the mark on water surfaces for paddling players
wake
{
	{
		clampmap sprites/splash.tga
		blendfunc add
		rgbGen wave sin 0.7 0.3 0.25 0.5 
		tcMod rotate 250
		tcMod stretch sin 0.9 0.1 0 0.7 
	}
	{
		clampmap sprites/splash.tga
		blendfunc add
		rgbGen wave sin 0.7 0.3 0.25 0.4 
		tcMod rotate -230
		tcMod stretch sin 0.9 0.05 0 0.9 
	}
}

// viewBloodBlend gives the blended directional cue when you get hit
viewBloodBlend
{
	sort nearest
	{
		map gfx/damage/blood_screen.tga
		blendfunc blend
		rgbGen identityLighting
		alphaGen Vertex
	}
}

waterBubble
{
	sort underwater
	cull disable
	{
		map sprites/bubble.tga
		blendfunc blend
		rgbGen Vertex
		alphaGen Vertex
	}
}

smokePuff
{
	cull disable
	{
		map gfx/misc/smokepuff3.tga
		blendfunc blend
		rgbGen Vertex
		alphaGen Vertex
	}
}

// drops behind player's feet when speeded
hasteSmokePuff
{
	cull disable
	{
		map gfx/misc/smokepuff3.tga
		blendfunc blend
		rgbGen Vertex
		alphaGen Vertex
	}
}

smokePuffRagePro
{
	cull disable
	{
		map gfx/misc/smokepuffragepro.tga
		blendfunc blend
	}
}

shotgunSmokePuff
{
	cull disable
	{
		map gfx/misc/smokepuff2b.tga
		blendfunc blend
		rgbGen entity
		alphaGen entity
	}
}

flareShader
{
	cull disable
	{
		map gfx/misc/flare.tga
		blendfunc add
		rgbGen Vertex
	}
}

sun
{
	cull disable
	{
		map gfx/misc/sun.tga
		blendfunc add
		rgbGen Vertex
	}
}

railDisc
{
	sort nearest
	cull disable
	deformVertexes wave 100 sin 0 0.5 0 2.4 
	{
		clampmap gfx/misc/raildisc_mono2.tga
		blendfunc add
		rgbGen Vertex
		tcMod rotate -30
	}
}

railCore
{
	sort nearest
	cull disable
	{
		map gfx/misc/railcorethin_mono.tga
		blendfunc add
		rgbGen Vertex
		tcMod scroll -1 0
	}
}

lightningBolt
{
	cull disable
	{
		map gfx/misc/lightning3.tga
		blendfunc add
		rgbGen wave sin 1 0.5 0 7.1 
		tcMod scale 2 1
		tcMod scroll -5 0
	}
	{
		map gfx/misc/lightning3.tga
		blendfunc add
		rgbGen wave sin 1 0.8 0 8.1 
		tcMod scale -1.3 -1
		tcMod scroll -7.2 0
	}
}

// shader used on the occasional machinegun bullet tracers
gfx/misc/tracer
{
	cull disable
	{
		map gfx/misc/tracer2.tga
		blendfunc add
	}
}

//
// wall marks
// use blendFunc GL_ZERO GL_ONE_MINUS_SRC_COLOR so that
// their "contribution" can be damped down in fog volumes
// with distance
bloodMark
{
	nopicmip
	polygonoffset
	{
		clampmap gfx/damage/blood_stain.tga
		blendfunc blend
		rgbGen identityLighting
		alphaGen Vertex
	}
}

bloodTrail
{
	nopicmip
	{
		clampmap gfx/damage/blood_spurt.tga
		blendfunc blend
		rgbGen Vertex
		alphaGen Vertex
	}
}

gfx/damage/bullet_mrk
{
	polygonoffset
	{
		map gfx/damage/bullet_mrk.tga
		blendfunc gl_zero gl_one_minus_src_color
		rgbGen Vertex
	}
}

gfx/damage/burn_med_mrk
{
	polygonoffset
	{
		map gfx/damage/burn_med_mrk.tga
		blendfunc gl_zero gl_one_minus_src_color
		rgbGen Vertex
	}
}

gfx/damage/hole_lg_mrk
{
	polygonoffset
	{
		map gfx/damage/hole_lg_mrk.tga
		blendfunc gl_zero gl_one_minus_src_color
		rgbGen Vertex
	}
}

gfx/damage/plasma_mrk
{
	polygonoffset
	{
		map gfx/damage/plasma_mrk.tga
		blendfunc blend
		rgbGen Vertex
		alphaGen Vertex
	}
}

//===============================================================
// scoreboard header tabs
scoreboardName
{
	nomipmaps
	{
		clampmap menu/tab/name.tga
		blendfunc blend
	}
}

scoreboardScore
{
	nomipmaps
	{
		clampmap menu/tab/score.tga
		blendfunc blend
	}
}

scoreboardTime
{
	nomipmaps
	{
		clampmap menu/tab/time.tga
		blendfunc blend
	}
}

scoreboardPing
{
	nomipmaps
	{
		clampmap menu/tab/ping.tga
		blendfunc blend
	}
}

//===============================================================
gfx/2d/crosshair
{
	nopicmip
	{
		map gfx/2d/crosshair.tga
		blendfunc blend
		rgbGen identity
	}
}

gfx/2d/crosshairb
{
	nopicmip
	{
		map gfx/2d/crosshairb.tga
		blendfunc blend
		rgbGen identity
	}
}

gfx/2d/crosshairc
{
	nopicmip
	{
		map gfx/2d/crosshairc.tga
		blendfunc blend
		rgbGen identity
	}
}

gfx/2d/crosshaird
{
	nopicmip
	{
		map gfx/2d/crosshaird.tga
		blendfunc blend
		rgbGen identity
	}
}

gfx/2d/crosshaire
{
	nopicmip
	{
		map gfx/2d/crosshaire.tga
		blendfunc blend
		rgbGen identity
	}
}

gfx/2d/crosshairf
{
	nopicmip
	{
		map gfx/2d/crosshairf.tga
		blendfunc blend
		rgbGen identity
	}
}

gfx/2d/crosshairg
{
	nopicmip
	{
		map gfx/2d/crosshairg.tga
		blendfunc blend
		rgbGen identity
	}
}

gfx/2d/crosshairh
{
	nopicmip
	{
		map gfx/2d/crosshairh.tga
		blendfunc blend
		rgbGen identity
	}
}

gfx/2d/crosshairi
{
	nopicmip
	{
		map gfx/2d/crosshairi.tga
		blendfunc blend
		rgbGen identity
	}
}

gfx/2d/crosshairj
{
	nopicmip
	{
		map gfx/2d/crosshairj.tga
		blendfunc blend
		rgbGen identity
	}
}

gfx/2d/crosshairk
{
	nopicmip
	{
		map gfx/2d/crosshairk.tga
		blendfunc blend
		rgbGen identity
	}
}

gfx/2d/bigchars
{
	nomipmaps
	{
		map gfx/2d/bigchars.tga
		blendfunc blend
		rgbGen Vertex
	}
}

gfx/2d/select
{
	nopicmip
	{
		map gfx/2d/select.tga
		blendfunc blend
		rgbGen Vertex
	}
}

gfx/2d/assault1d
{
	nopicmip
	{
		map gfx/2d/assault1d.tga
		blendfunc blend
	}
}

gfx/2d/armor1h
{
	nopicmip
	{
		map gfx/2d/armor1h.tga
		blendfunc blend
	}
}

gfx/2d/health
{
	nopicmip
	{
		map gfx/2d/health.tga
		blendfunc blend
	}
}

gfx/2d/blank
{
	nopicmip
	{
		map gfx/2d/blank.tga
		blendfunc blend
	}
}

gfx/2d/numbers/zero_32b
{
	nopicmip
	{
		map gfx/2d/numbers/zero_32b.tga
		blendfunc blend
		rgbGen Vertex
	}
}

gfx/2d/numbers/one_32b
{
	nopicmip
	{
		map gfx/2d/numbers/one_32b.tga
		blendfunc blend
		rgbGen Vertex
	}
}

gfx/2d/numbers/two_32b
{
	nopicmip
	{
		map gfx/2d/numbers/two_32b.tga
		blendfunc blend
		rgbGen Vertex
	}
}

gfx/2d/numbers/three_32b
{
	nopicmip
	{
		map gfx/2d/numbers/three_32b.tga
		blendfunc blend
		rgbGen Vertex
	}
}

gfx/2d/numbers/four_32b
{
	nopicmip
	{
		map gfx/2d/numbers/four_32b.tga
		blendfunc blend
		rgbGen Vertex
	}
}

gfx/2d/numbers/five_32b
{
	nopicmip
	{
		map gfx/2d/numbers/five_32b.tga
		blendfunc blend
		rgbGen Vertex
	}
}

gfx/2d/numbers/six_32b
{
	nopicmip
	{
		map gfx/2d/numbers/six_32b.tga
		blendfunc blend
		rgbGen Vertex
	}
}

gfx/2d/numbers/seven_32b
{
	nopicmip
	{
		map gfx/2d/numbers/seven_32b.tga
		blendfunc blend
		rgbGen Vertex
	}
}

gfx/2d/numbers/eight_32b
{
	nopicmip
	{
		map gfx/2d/numbers/eight_32b.tga
		blendfunc blend
		rgbGen Vertex
	}
}

gfx/2d/numbers/nine_32b
{
	nopicmip
	{
		map gfx/2d/numbers/nine_32b.tga
		blendfunc blend
		rgbGen Vertex
	}
}

gfx/2d/numbers/minus_32b
{
	nopicmip
	{
		map gfx/2d/numbers/minus_32b.tga
		blendfunc blend
		rgbGen Vertex
	}
}

//
// weapon hits
// All of these will be put on entities with a shaderTime offset, so they
// can be expected to start at time 0 for each separate explosion
//
// Many of these are use smoothly morphed animating textures by pairing
// sawtooth and iverse sawtooth rgbGens
plasmaExplosion
{
	cull disable
	{
		clampmap models/weaphits/plasmaboom.tga
		blendfunc add
		rgbGen wave inversesawtooth 0 1 0 1.5 
		tcMod stretch triangle 0.6 0.1 0 8 
		tcMod rotate 999
	}
}

railExplosion
{
	cull disable
	{
		animmap 5 models/weaphits/ring02_1.tga models/weaphits/ring02_2.tga models/weaphits/ring02_3.tga models/weaphits/ring02_4.tga gfx/colors/black.tga 
		blendfunc blend
		alphaGen wave inversesawtooth 0 1 0 5 
	}
	{
		animmap 5 models/weaphits/ring02_2.tga models/weaphits/ring02_3.tga models/weaphits/ring02_4.tga gfx/colors/black.tga gfx/colors/black.tga 
		blendfunc blend
		alphaGen wave sawtooth 0 1 0 5 
	}
}

lightningExplosion
{
	cull disable
	{
		animmap 5 models/weaphits/ring02_1.tga models/weaphits/ring02_3.tga models/weaphits/ring02_3.tga gfx/colors/black.tga 
		blendfunc add
		rgbGen wave inversesawtooth 0 1 0 5 
	}
	{
		animmap 5 models/weaphits/ring02_2.tga models/weaphits/ring02_3.tga gfx/colors/black.tga gfx/colors/black.tga 
		blendfunc add
		rgbGen wave sawtooth 0 1 0 5 
	}
}

bulletExplosion
{
	cull disable
	{
		animmap 5 models/weaphits/bullet1.tga models/weaphits/bullet2.tga models/weaphits/bullet3.tga gfx/colors/black.tga 
		blendfunc add
		rgbGen wave inversesawtooth 0 1 0 5 
	}
	{
		animmap 5 models/weaphits/bullet2.tga models/weaphits/bullet3.tga gfx/colors/black.tga gfx/colors/black.tga 
		blendfunc add
		rgbGen wave sawtooth 0 1 0 5 
	}
}

rocketExplosion
{
	cull disable
	{
		animmap 8 models/weaphits/rlboom/rlboom_1.tga models/weaphits/rlboom/rlboom_2.tga models/weaphits/rlboom/rlboom_3.tga models/weaphits/rlboom/rlboom_4.tga models/weaphits/rlboom/rlboom_5.tga models/weaphits/rlboom/rlboom_6.tga models/weaphits/rlboom/rlboom_7.tga models/weaphits/rlboom/rlboom_8.tga 
		blendfunc add
		rgbGen wave inversesawtooth 0 1 0 8 
	}
	{
		animmap 8 models/weaphits/rlboom/rlboom_2.tga models/weaphits/rlboom/rlboom_3.tga models/weaphits/rlboom/rlboom_4.tga models/weaphits/rlboom/rlboom_5.tga models/weaphits/rlboom/rlboom_6.tga models/weaphits/rlboom/rlboom_7.tga models/weaphits/rlboom/rlboom_8.tga gfx/colors/black.tga 
		blendfunc add
		rgbGen wave sawtooth 0 1 0 8 
	}
}

grenadeExplosion
{
	cull disable
	{
		animmap 5 models/weaphits/glboom/glboom_1.tga models/weaphits/glboom/glboom_2.tga models/weaphits/glboom/glboom_3.tga 
		blendfunc add
		rgbGen wave inversesawtooth 0 1 0 5 
	}
	{
		animmap 5 models/weaphits/glboom/glboom_2.tga models/weaphits/glboom/glboom_3.tga gfx/colors/black.tga 
		blendfunc add
		rgbGen wave sawtooth 0 1 0 5 
	}
}

bfgExplosion
{
	cull disable
	{
		animmap 5 models/weaphits/bfgboom/bfgboom_1.tga models/weaphits/bfgboom/bfgboom_2.tga models/weaphits/bfgboom/bfgboom_3.tga 
		blendfunc add
		rgbGen wave inversesawtooth 0 1 0 5 
	}
	{
		animmap 5 models/weaphits/bfgboom/bfgboom_2.tga models/weaphits/bfgboom/bfgboom_3.tga gfx/colors/black.tga 
		blendfunc add
		rgbGen wave sawtooth 0 1 0 5 
	}
}

// spurt of blood at point of impact
bloodExplosion
{
	cull disable
	{
		animmap 5 models/weaphits/blood201.tga models/weaphits/blood202.tga models/weaphits/blood203.tga models/weaphits/blood204.tga models/weaphits/blood205.tga 
		blendfunc blend
	}
}

